%Make matrix for Poisson equation
L = 16*[-0.25 0.25 0 0 0;0 -2 2 0 0;0 0.5 -2 1.5 0;0 0 2/3 -2 4/3;0 0 0 0 1/16];

%invert matrix
Li = inv(L);

%Define initalizations
phi_n   = [1.0;1.0;1.0;0;0];
pi_n    = [0;0;0;0;0];
V_n     = [0;0;0;0;0];
psi2    = [0;0;0;0;0];
phinp1  = [0;0;0;0;0];
pinp1   = [0;0;0;0;0];
phi_np1 = [0;0;0;0;0];
pi_np1  = [0;0;0;0;0];
V_np1   = [0;0;0;0;0];
Vnp1    = [0;0;0;0;0];

%Define matricies just for saving data
phi_np1row = [0,0,0,0,0];
pi_np1row  = [0,0,0,0,0];
V_np1row   = [0,0,0,0,0];

convg = 0;

psi2 = phi_n.*phi_n;
V_n = Li*psi2;

% Initially set advanced time level to retarted time level
phinp1 = phi_n;
pinp1  = pi_n;
Vnp1   = V_n;
%Save initialization
for i=[1,2,3,4,5]
    phi_np1row(i) = phinp1(i);
    pi_np1row(i)  = pinp1(i);
    V_np1row(i)   = V_n(i);
end

dlmwrite('V.txt', V_np1row);
dlmwrite('phi.txt', phi_np1row);
dlmwrite('pi.txt', pi_np1row);

for i=[1,2,3]
    while convg < 5
          for j=[2,3,4]
              pi_np1(j) = pi_n(j) + (0.8/(4*0.25))*( phinp1(j+1) - 2*phinp1(j) + phinp1(j-1) + phi_n(j+1) - 2*phi_n(j) + phi_n(j-1) ) + (0.8/(4*0.25*(j-1)))*( phinp1(j+1) - phinp1(j-1) + phi_n(j+1) - phi_n(j-1) ) - 0.8*0.25*0.5*( phinp1(j)*Vnp1(j) + phi_n(j)*V_n(j) ); 
 
              phi_np1(j) = phi_n(j) - (0.8/(4*0.25))*( pinp1(j+1) - 2*pinp1(j) + pinp1(j-1) + pi_n(j+1) - 2*pi_n(j) + pi_n(j-1) ) - (0.8/(4*0.25*(j-1)))*( pinp1(j+1) - pinp1(j-1) + pi_n(j+1) - pi_n(j-1) ) + 0.8*0.25*0.5*( pinp1(j)*Vnp1(j) + pi_n(j)*V_n(j) );
           end
           pi_np1(1)  = pi_np1(2);
           pi_np1(5)  = 0.0;
           phi_np1(1) = phi_np1(2);
           phi_np1(5) = 0.0;

           psi2  = phi_np1.*phi_np1 + pi_np1.*pi_np1;
           V_np1 = Li*psi2;

for k=[1,2,3,4,5]
    phi_np1row(k) = phi_np1(k);
    pi_np1row(k)  = pi_np1(k);
    V_np1row(k)   = V_np1(k);
end
dlmwrite('V.txt', V_np1row, '-append');
dlmwrite('phi.txt', phi_np1row, '-append');
dlmwrite('pi.txt', pi_np1row, '-append');

%Check for convergence
           for j=[1,2,3,4,5]
               if abs(V_np1(j) - Vnp1(j)) < 0.01
                  convg = convg + 1;
               end
           end
% If here, then no convergence
    convg = 0;
    Vnp1 = V_np1;
    phinp1 = phi_np1;
    pinp1  = pi_np1;
    end
%Convergenece success
%After convergence, save data
for k=[1,2,3,4,5]
    phi_np1row(k) = phi_np1(k);
    pi_np1row(k)  = pi_np1(k);
    V_np1row(k)   = V_np1(k);
end
dlmwrite('V.txt', V_np1row, '-append');
dlmwrite('phi.txt', phi_np1row, '-append');
dlmwrite('pi.txt', pi_np1row, '-append');

%Reset variables
convg = 0;
for k=[1,2,3,4,5]
    phinp1(k) = phi_np1(k);
    pinp1(k)  = pi_np1(k);
    phi_n(k)  = phi_np1(k);
    pi_n(k)   = pi_np1(k);
end

end
