      integer j, Nx, iterc, convg, inform
c      real*8 D(g1_Nx), DU(g1_Nx - 1), DL(g1_Nx - 1),B(g1_Nx)
c      real*8 Vnp1(g1_Nx), phinp1(g1_Nx), pinp1(g1_Nx)
c      real*8 invert

      Nx = g1_Nx
      iterc = 1
      convg = 0
      inform = 0
c--------------------------------------------
c Define B
c--------------------------------------------
      do j = 1, Nx
         B(j) = (phi_n(j))**2 + (pi_n(j))**2
      end do
c      write(0,*) 'B Defined'
c-------------------------------------------
c Initialization of V
c-------------------------------------------
      if ( vpass .eq. 1 ) then
      call vsxynt('Bo',t,x,B,Nx)
      call vsxynt('phi_n',t,x,phi_n,Nx)
      call vsxynt('phi_np1',t,x,phi_np1,Nx)

      write(0,*) 'Initializing V'
c--------------------------------------------
cDefine diagonal, superdiagonal, & subdiagonal
c--------------------------------------------
      write(0,*) 'Defining D, DL, DU'
      do j = 2, Nx-1
         D(j) = (-2.0d0)/(dx**2)
      end do 
         D(1) = (-1.0d0)/dx
         D(Nx) = 1.0d0

      do j = 2, Nx-1
         DU(j) = ((1.0d0)/(dx**2))*(1.0d0 + (1.0d0)/(j - 1.0d0))
      end do
         DU(1) = 1.0d0/dx

      do j = 1, Nx-2
         DL(j) = ((1.0d0)/(dx**2))*(1.0d0 - (1.0d0)/(j))
      end do
         DL(Nx-1) = 0
      write(0,*) 'DL,DU,D Defined'
      write(0,*) DL
      write(0,*) DU
      write(0,*) D
c---------------------------------------------
c Call LAPACK to initialize V
c---------------------------------------------
         write(0,*) 'Calling DGTSV to solve initial V'

         call DGTSV( Nx, 1, DL, D, DU, B, Nx, inform )
c         call invert( DL, D, DU, B )
         write(0,*) 'INFO =', inform
         write(0,*) 'Initial V solved'
         write(0,*) 'DGTSV output:'
         write(0,*) DL
         write(0,*) DU
         write(0,*) D

         do j = 1, Nx
            V_n(j)   = B(j)
            write(0,*) V_n(j)
c            write(0,*) dx
         end do

         write(0,*) 'Initialization of V complete'     
      call vsxynt('Vo',t,x,V_n,Nx)
      end if

      if ( vpass .eq. 0 ) then
c       write(0,*) 'Begin update of pi, phi, V'
      call vsxynt('V_nstart',t,x,V_n,Nx)
c      call vsxynt('v_np1loop',t,x,V_np1,Nx)
      call vsxynt('phi_nstart',t,x,phi_n,Nx)
c      call vsxynt('phi_np1loop',t,x,phi_np1,Nx)
      call vsxynt('pi_nstart',t,x,pi_n,Nx)
c      call vsxynt('pi_np1loop',t,x,pi_np1,Nx)
c------------------------------------------------------------
c Initially set advanced time level to retarted time level
c---------------------------------------------------------
      do j = 1,Nx
         phinp1(j) = phi_n(j)
         pinp1(j)  = pi_n(j)
         Vnp1(j)   = V_n(j)
c         write(0,*) Vnp1(j)
      end do

c---------------------------------------------
c Main update loop
c---------------------------------------------
      do while ( ( convg .LT. Nx ) .AND. ( iterc .LT. iter ) )
c      write(0,*) 'Main Loop Begin'
c---------------------------------------------
c Setup Intermediate variables for convergence checking
c---------------------------------------------
c      write(0,*) 'Define phinp1,pinp1,Vnp1'
c     write(0,*) 'Solve phi_np1 holding pinp1 & Vnp1 constant'
      do j = 2,Nx-1
      phi_np1(j) = phi_n(j) - 0.25d0*(dt/(dx**2))*( pinp1(j+1) 
     & - 2.0d0*pinp1(j) + pinp1(j-1) + pi_n(j+1) - 2.0d0*pi_n(j) 
     & + pi_n(j-1) )
     & - 0.25d0*(dt/((j-1)*dx**2))*( pinp1(j+1) - pinp1(j-1) 
     & + pi_n(j+1) - pi_n(j-1) )
     & + 0.5d0*dt*( pinp1(j)*Vnp1(j) + pi_n(j)*V_n(j) )

c       write(0,*) phi_np1(j)
c      write(0,*) 'Solve pi_np1 holding phinp1 & Vnp1 constant'

      pi_np1(j) = pi_n(j) + 0.25d0*(dt/(dx**2))*( phinp1(j+1) 
     & - 2.0d0*phinp1(j) + phinp1(j-1) + phi_n(j+1) - 2.0d0*phi_n(j) 
     & + phi_n(j-1) )
     & + 0.25d0*(dt/((j-1)*dx**2))*( phinp1(j+1) - phinp1(j-1) 
     & + phi_n(j+1) - phi_n(j-1) )
     & - 0.5d0*dt*( phinp1(j)*Vnp1(j) + phi_n(j)*V_n(j) )

c      write(0,*) 'Determine B for calculation of V'
      B(j) = (phi_np1(j))**2 + (pi_np1(j))**2
c      call vsxynt('phi_np1loop',t,x,phi_np1,Nx)

       end do     
c----------------------------------------
c Calculate values at the boundary
c-----------------------------------------

      pi_np1(1) = pi_np1(2)
      pi_np1(Nx) = 0
      phi_np1(1)  = phi_np1(2)
      phi_np1(Nx) = 0
      B(Nx) = 0
      B(1) = (phi_np1(1))**2 + (pi_np1(1))**2

      call vsxynt('phi_np1end',t,x,phi_np1,Nx)

c      write(0,*) 'phi_np1, pi_np1, B calculated'

c-----------------------------------------------------------
c Redefine L and update V
c-----------------------------------------------------------
c      write(0,*) 'calculate D, DL, DU'

      do j = 2, Nx-1
         D(j) = -2.0d0/(dx**2)
      end do 
         D(1) = -1.0d0/dx
         D(Nx) = 1.0d0

      do j = 2, Nx-1
         DU(j) = (1.0d0/(dx**2))*(1.0d0 + 1.0d0/(j - 1.0d0))
      end do
         DU(1) = 1.0d0/dx

      do j = 1, Nx-2
         DL(j) = (1.0d0/(dx**2))*(1.0d0 - 1.0d0/(j))
      end do
         DL(Nx-1) = 0
    
c      write(0,*) 'call DGTSV to solve V'
         call DGTSV( Nx, 1, DL, D, DU, B, Nx,inform )
c      write(0,*) 'INFO = ',inform
c      write(0,*) 'V calculated'

c---------------------------------------------------------
c Check for convergence
c---------------------------------------------------------
c      write(0,*) 'Check for Convergence'
         do j = 1, Nx
            V_np1(j) = B(j)
            if ( DABS(V_np1(j) - Vnp1(j)) .LT. epsiter ) then
               convg = convg + 1
            endif
c            write(0,*) DABS(V_np1(j) - Vnp1(j))
         end do
c      write(0,*) 'Convergence test complete'
c      write(0,*) 'convg =', convg
c----------------------------------------------------------
c No convergence. Set counter variables
c---------------------------------------------------------
c      write(0,*) 'No convergence after ', iterc, ' iteration(s)'
      convg = 0
      iterc = iterc + 1

      
      do j = 1,Nx
         phinp1(j) = phi_np1(j)
         pinp1(j)  = pi_np1(j)
         Vnp1(j)   = V_np1(j)
      end do
      end do
      endif
